unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, StdCtrls;

type
  TfrmMain = class(TForm)
    lbUsername: TLabel;
    txtUsername: TEdit;
    lbSerial: TLabel;
    txtSerial: TEdit;
    btnCheck: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnCheckClick(Sender: TObject);
  private
    FUsername: WideString;
    FSerial: WideString;
    procedure WMCommand(var Msg: TWMCommand); message WM_COMMAND;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses
  uStrings;

{******************************************************************************}

{$I FAKE.INC}
// 
procedure TfrmMain.btnCheckClick(Sender: TObject);
begin
  FakeCheck(WideString(txtUsername.Text), txtSerial.Text);
end;

{******************************************************************************}

{$R KEYS\KEYS.RES}

const
  mainKey = PWideChar(900);
  tempKey = PWideChar(901);

{******************************************************************************}

// GetProcAddr by bagie: identical to KERNEL32!GetProcAddress
// originally written in fasm and ported to Delphi
// <- EDX - base of module
// <- EAX - name\ordinal
// -> EAX - function address
// NOTE: this function will fail with redirected exports
// for example with KERNEL32!RtlZeroMemory params it returns pointer to ASCIIZ-string 'NTDLL.RtlZeroMemory'
// in this case you must check that returned pointer in memory range of export table of needed module
// then parse returned string and repeat to call GetProcAddr with new params
// PS: I was too lazy to solve this problem :)
function GetProcAddr(lpProcName: LPCSTR; hModule: HMODULE): FARPROC; register;
var
  _OrdinalBase: DWORD;
  _AddressOfNameOrdinals: DWORD;
  _AddressOfFunctions: DWORD;   
asm
  push ebx
  push edi
  push esi
  test edx,0ffff0000h
  je @error
  mov esi,edx
  mov ecx,[esi+IMAGE_DOS_HEADER._lfanew]
  mov ecx,[esi+ecx+IMAGE_NT_HEADERS.OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT]+IMAGE_DATA_DIRECTORY.VirtualAddress]
  or ecx,ecx
  je @error
  lea edx,[esi+ecx]
  mov ecx,[edx+IMAGE_EXPORT_DIRECTORY.Base]
  or ecx,ecx
  je @error
  mov [_OrdinalBase],ecx
  mov ecx,[edx+IMAGE_EXPORT_DIRECTORY.AddressOfNameOrdinals]
  jecxz @error
  lea ecx,[esi+ecx]
  mov [_AddressOfNameOrdinals],ecx
  mov ecx,[edx+IMAGE_EXPORT_DIRECTORY.AddressOfFunctions]
  jecxz @error
  lea ecx,[esi+ecx]
  mov [_AddressOfFunctions],ecx
  test eax,0ffff0000h
  je @by_ordinal
  mov ecx,[edx+IMAGE_EXPORT_DIRECTORY.NumberOfNames]
  jecxz @error
  push ecx
  mov edi,eax
  or ecx,-1
  xor al,al
  repne scasb
  not ecx
  sub edi,ecx
  pop eax
  mov edx,[edx+IMAGE_EXPORT_DIRECTORY.AddressOfNames]
  or edx,edx
  je @error
  push edi
  push ecx
  lea edx,[esi+edx]
  mov ecx,eax
  xor eax,eax
  mov ebx,esi
@@:
  push ecx
  mov ecx,[esp+4]
  mov edi,[esp+8]
  mov esi,[edx]
  add esi,ebx
  add edx,4
  inc eax
  repe cmpsb
  pop ecx
  loopne @@
  jne @error
  pop edi
  pop edi
  mov edx,[_AddressOfNameOrdinals]
  movzx eax,word ptr [edx+eax*2-2]
  jmp @get_func_addr
@by_ordinal:
  cmp eax,[_OrdinalBase]
  jb @error
  sub eax,[_OrdinalBase]
  mov ebx,esi
@get_func_addr:
  mov edx,[_AddressOfFunctions]
  mov eax,[edx+eax*4]
  or eax,eax
  je @exit
  add eax,ebx
@exit:
  pop esi
  pop edi
  pop ebx
  jmp @ret
@error:
  xor eax,eax
  jmp @exit
@ret:
end;

type
  PMSGBOXDATA = ^_MSGBOXDATA;
  _MSGBOXDATA = record
    mbp: MSGBOXPARAMSW;
    hwndOwner: HWND;
    wLanguageId: DWORD;
    pidButton: PDWORD;
    ppszButtonText: PWideChar;
    dwButtons: DWORD;
    dwDefButton: DWORD;
    dwCancelId: DWORD;
    dwTimeout: DWORD;
  end;

type
  TGetModuleHandleW = function(lpModuleName: PWideChar): HMODULE; stdcall;
  TGetProcAddress = function(hModule: HMODULE; lpProcName: LPCSTR): FARPROC; stdcall;
  TSoftModalMessageBox = function(pmbData: PMSGBOXDATA): Integer; stdcall;

function MyGetProcAddr(hModule: HMODULE; lpProcName: LPCSTR): FARPROC;
var
  GPA: TGetProcAddress;
begin            
  Result := nil;
  try
    Result := GetProcAddr(lpProcName, hModule);
  except
    GPA := GetProcAddress;
    if Assigned(GPA) then
      Result := GPA(hModule, lpProcName);
  end;
end;

procedure ShowMessage(hWnd: HWND; Text, Caption: WideString; Style: DWORD);
const
  User32DllString: array[0..10] of WideChar = (
    #$75B1, #$6319, #$7A43, #$D819, #$96AF, #$898B, #$4A89, #$5955, #$E79D, #$C114, #0);
  SoftModalMessageBoxString: array[0..19] of WideChar = (
    #$75B7, #$6325, #$7A60, #$D83F, #$96D1, #$89D6, #$4AC3, #$5970, #$E7BD, #$C115,
    #$D669, #$47A2, #$0376, #$F13E, #$D5D4, #$8CA5, #$D9A4, #$DEB2, #$3BAF, #0);
  OkString: array[0..3] of WideChar = (#$75C2, #$6305, #$7A4D, #0);
var
  GetModuleHandle: TGetModuleHandleW;
  MsgBoxProc: TSoftModalMessageBox;
  Button1Id: DWORD;
  Button1Text: array[0..Length(OkString)-1] of WideChar;
  Button1TextPtr: PWideChar;
  mbData: _MSGBOXDATA;
begin
  GetModuleHandle := GetModuleHandleW;

  MsgBoxProc := MyGetProcAddr(
    GetModuleHandle(PWideChar(CryptString(User32DllString, mainKey))),
    PChar(AnsiString(CryptString(SoftModalMessageBoxString, mainKey)))
    );
  if not Assigned(MsgBoxProc) then Exit;

  FillChar(mbData, SizeOf(mbData), 0);

  Button1Id := ID_OK;
  MoveMemory(@Button1Text, PWideChar(CryptString(OkString, mainKey)), SizeOf(OkString));
  Button1TextPtr := @Button1Text;

  with mbData do
  begin
    dwButtons := 1;
    dwDefButton := 0;
    pidButton := @Button1Id;
    ppszButtonText := @Button1TextPtr; // some problem on Win7 detected...
    hwndOwner := hWnd;
    dwCancelId := ID_CANCEL;
    dwTimeout := DWORD(-1);
  end;
  
  with mbData.mbp do
  begin
    cbSize := SizeOf(mbData.mbp);
    hwndOwner := hWnd;
    lpszText := PWideChar(Text);
    lpszCaption := PWideChar(Caption);
    dwStyle := Style;
  end;
  
  mbData.mbp.hInstance := hInstance;

  asm
    mov eax,fs:[18h]
    mov eax,[eax+30h]
    mov byte ptr [eax+2],0 
  end;

  MsgBoxProc(@mbData);
end;
  
{******************************************************************************}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Self.Caption := Application.Title;
  Randomize();
  
end;

type
  TSendMessageTimeoutW = function(hWnd: HWND; Msg: UINT; wParam: WPARAM;
    lParam: LPARAM; fuFlags, uTimeout: UINT; var lpdwResult: DWORD): LRESULT; stdcall;

procedure TfrmMain.WMCommand(var Msg: TWMCommand);
const
  User32DllString: array[0..10] of WideChar = (
    #$75B1, #$6319, #$7A43, #$D819, #$96AF, #$898B, #$4A89, #$5955, #$E79D, #$C114, #0);
  SendMessageTimeoutWString: array[0..19] of WideChar = (
    #$75B7, #$632F, #$7A68, #$D82F, #$96D1, #$89DC, #$4AD4, #$5962, #$E7B0, #$C13F,
    #$D669, #$4785, #$036C, #$F132, #$D5D6, #$8CAF, #$D993, #$DEA9, #$3B80, #0);
  NotValidInputString: array[0..68] of WideChar = (
    #$75A1, #$6324, #$7A72, #$D82E, #$96EE, #$8999, #$4ADE, #$597E, #$E7A4, #$C12A,
    #$D62C, #$47BF, #$0364, #$F132, #$D5D6, #$8CE0, #$D987, #$DEB3, #$3BB3, #$E0EC,
    #$1015, #$095B, #$8F2D, #$0944, #$062A, #$C884, #$8F53, #$9681, #$7AC6, #$5950,
    #$5047, #$3C06, #$0B7F, #$0CCA, #$8A2D, #$0D67, #$6B77, #$72F5, #$F69F, #$5917,
    #$F868, #$6370, #$5E91, #$5A0D, #$A1CF, #$B079, #$C6A7, #$9443, #$141E, #$1E44,
    #$A6A6, #$9A66, #$C42A, #$EE9D, #$93EB, #$7E98, #$1E80, #$689F, #$CB32, #$BE0D,
    #$F405, #$BF48, #$9FA9, #$6E9B, #$C4A9, #$16CD, #$0D7C, #$D11A, #0);
  SuccessString: array[0..18] of WideChar = (
    #$75A3, #$6325, #$7A69, #$D82F, #$96BC, #$89CE, #$4AC8, #$5963, #$E7BA, #$C179,
    #$D62C, #$4792, #$036D, #$F13A, #$D5D6, #$8CB2, #$D995, #$DEFC, #0);
  InvalidSerialString: array[0..22] of WideChar = (
    #$75AD, #$6324, #$7A70, #$D82A, #$96F0, #$89D0, #$4AC3, #$5931, #$E7A2, #$C13D,
    #$D67E, #$47B8, #$0364, #$F133, #$D593, #$8CAE, #$D993, #$DEB0, #$3BB5, #$E0A9,
    #$1014, #$091F, #0);
var
  GetModuleHandle: TGetModuleHandleW;
  SendMessageTimeoutW: TSendMessageTimeoutW;
  Buffer: array of WideChar;
  MsgResult: DWORD;
  username: WideString; 
  dc1: hdc;
  bmp1: HBITMAP;
  dc2: hdc;
  bmp2: HBITMAP;
begin
  GetModuleHandle := GetModuleHandleW;

  SendMessageTimeoutW := MyGetProcAddr(
    GetModuleHandle(PWideChar(CryptString(User32DllString, mainKey))),
    PChar(AnsiString(CryptString(SendMessageTimeoutWString, mainKey)))
    );
  if not Assigned(SendMessageTimeoutW) then Exit;

  if Msg.NotifyCode = EN_CHANGE then
  begin
    if Msg.Ctl = txtUsername.Handle then
    begin
      if BOOL(SendMessageTimeoutW(Msg.Ctl, WM_GETTEXTLENGTH, 0, 0,
        SMTO_NORMAL, DWORD(-1), MsgResult)) then
      begin
        SetLength(Buffer, MsgResult + 1);
        if BOOL(SendMessageTimeoutW(Msg.Ctl, WM_GETTEXT,
          MsgResult, LPARAM(@Buffer[0]), SMTO_NORMAL, DWORD(-1), MsgResult)) then
        begin
          Buffer[Length(Buffer) - 1] := #0;
          FUsername := CryptString(PWideChar(@Buffer[0]), tempKey);
        end;
      end;
      Msg.Result := 0;
    end;

    if Msg.Ctl = txtSerial.Handle then
    begin
      if BOOL(SendMessageTimeoutW(Msg.Ctl, WM_GETTEXTLENGTH, 0, 0,
        SMTO_NORMAL, DWORD(-1), MsgResult)) then
      begin
        SetLength(Buffer, MsgResult + 1);
        if BOOL(SendMessageTimeoutW(Msg.Ctl, WM_GETTEXT,
          MsgResult, LPARAM(@Buffer[0]), SMTO_NORMAL, DWORD(-1), MsgResult)) then
        begin
          Buffer[Length(Buffer) - 1] := #0;
          FSerial := CryptString(PWideChar(@Buffer[0]), tempKey);
        end;
      end;
      Msg.Result := 0;
    end;
  end;

  if (Msg.NotifyCode = BN_CLICKED) or (Msg.NotifyCode = BN_PUSHED)  then
  begin
    if Msg.Ctl = btnCheck.Handle then
    begin
      if (Length(FUsername) - 5 < 0) or (Length(FSerial) = 0) then
        ShowMessage(Handle, CryptString(NotValidInputString, mainKey), '', MB_ICONWARNING)
      else begin
        //DebugBreak();

        username := CryptString(FUsername, tempKey);
        CreateMemoryContext(Length(username), dc1, bmp1);
        try
          StoreAndCryptString(dc1, username, mainKey);
          CreateMemoryContext(Length(username), dc2, bmp2);

          try
            StoreString(dc2, HexToString(CryptString(FSerial, tempKey)));

            try
              MsgResult := MsgResult div DWORD(not CompareMemoryContext(dc1, dc2, Length(username)));
              ShowMessage(Handle, CryptString(InvalidSerialString, mainKey), '', MB_ICONERROR);
            except
              ShowMessage(Handle, CryptString(SuccessString, mainKey), '', MB_ICONINFORMATION);
            end;

          finally
            DestroyMemoryContext(dc2, bmp2);
          end;

        finally
          DestroyMemoryContext(dc1, bmp1);
        end;
      end;

    end;
  end;
end;

end.
